<?php
/**
 * Erstellen und Herunterladen eines Backups.
 * Konfiguration anhand eines Backups wiederherstellen.
 * 
 * @author Miguel Palmer <mp@beronet.com>
 */
include('/usr/php/include/configExportImportTool.class.php');

class BackupRestore {

	private $_configFiles;
	private $_getImportConf;

    function __construct($m, $get = array(), $post = array(), $session = array()) {
		$this-> _getImportConf = new configExportImportTool;
		$this->_configFiles = $this->_getImportConf->getFileGroups();

	}

	/**
	 * Erstellt die Backup and Restore Seite
	 * @return string HTML Inhalt
	 */
	function display() {

		$name = "BACKUP_RESTORE_TITLE_DIS";
		include('./includes/header.php');
		ob_start();
		?>
		<script>
		let answer;
			function checkUploadedFile (fileName) {
				// check if file has a .xml extension
				if (fileName.slice(-4) === '.xml') {
					return confirm('<?php echo BACKUP_RESTORE_CONFIRM_MESSAGE_DIS ?>');
				}
				var baseName = fileName.replace(/.*\//, '');
				baseName = baseName.replace(/.*\\/, '');
				var allowedFiles = ['hardware.conf', 'isgw.analog', 'isgw.cas', 'isgw.causes', 'isgw.conf', 'isgw.cpt', 'isgw.dialplan','isgw.gsm', 'isgw.lte', 'isgw.isdn', 'isgw.sip', 'isgw.tdm', 'misc.conf', 'network.acl'];
				for (i = 0; i < allowedFiles.length; i++) {
					if (baseName == allowedFiles[i]) {
						return confirm('<?php echo BACKUP_RESTORE_CONFIRM_MESSAGE_DIS ?>');
					}
				}
				alert('<?php echo BACKUP_RESTORE_ALERT_MESSAGE_CONFIG_FILE; ?>');
				return false;
			}
			//ajax request to get  list of files in config, then popup with files to select
			function selectFiles(){
				$('#modal-grid').empty();
				var formData = new FormData($('#importForm')[0]);
				answer = $.ajax({
					type: 'POST',
					url: 'misc/upload.php?getFiles=true',
					data: formData,
					processData: false,
					mimeType: "multipart/form-data",
					contentType: false,
					success: function(){
						var configFiles= JSON.parse(answer.responseText);
						Object.keys(configFiles).forEach((fileGroup) => {
							if (configFiles[fileGroup] != 'appConfig') {
								$('#modal-grid').append(
							 		'<div style="padding: 8px;">'
										+'<label><br><input type="checkbox" form="importForm" name="configFiles['+fileGroup+']" value="'+fileGroup+'" checked="true" ><br>'+fileGroup+"</label>"
									+"</div>");
							} else {
								$('#modal-grid').append(
								'<div style="padding: 8px; ">'
									+'<label><input type="checkbox" checked="true" form="importForm" name="appConf" value="true"><br>App Config</label>'
								+'</div>'
							+'</div>');
							}
						});
						$('#upload-popup').modal('toggle');
					},
				});
			}
		</script>
		<br>
		<div class='modal fade bs-example-modal-lg' id='upload-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			<div class='modal-dialog modal-lg'>
				<div class='modal-content'>
					<div class='modal-header'>
						<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
						<h4><?php echo BACKUP_RESTORE_POPUP_TITLE?></h4>
					</div>
					<div id='modal-body' class='modal-body'>
						<div style='display: grid;
									grid-template-columns: 33% 33% 33% ;
									justify-content:space-around;
									text-align:left;' id='modal-grid'>		
						</div>
						<div class="row text-center">
							<input type=hidden name='groups' value="true">
 							<input type="submit" form='importForm' name='nofiles' class="btn btn-default" data-toggle="tooltip" title="<?php echo BACK_RES_UPLOAD ?>" value="<?php echo BUTTON_UPLOAD ?>">
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="panel panel-default" style="max-width:600px; margin:auto;">
			<div class="panel-heading text-center lead">
				<?php echo BACKUP_RESTORE_DOWNLOAD_DIS ?>
			</div>
			<div class="panel-body text-center">
			<form name="downloadFull" id="downloadFull" action="misc/files_download.php" method="GET"></form>
				<form name="download" action="misc/files_download.php" method="GET">
					<div style='display: grid;
								grid-template-columns: 40% 40%;
								justify-content:space-around;'>
						<?php foreach($this->_configFiles as $key => $file){
							echo '<div style="padding-top: 16px; text-align: center">'.
								'<label><input  style="text-align"type="checkbox" name="configFiles['.$key .']" value='.$key.'><br>'.
								$key."</label>"
							."</div>";
						}?>
						<div style="padding-top: 16px; text-align: center">
						<label><input type="checkbox" name="apps" value="true"><br>App Config</label>
						</div>
					</div>
					<button type="submit" class="btn btn-default" data-toggle="tooltip" name="selectFiles" value=true title="<?php echo BACK_RES_DOWNLOAD ?>" >
						<?php echo BACKUP_RESTORE_DOWNLOAD_LINK_DIS?>
					</button>
					<button type="submit" class="btn btn-default" data-toggle="tooltip" form="downloadFull" title="<?php echo BACK_RES_FULLDOWNLOAD ?>" >
						<?php echo BACKUP_RESTORE_FULLDOWNLOAD_LINK_DIS?>
					</button>
					</form>
				</form>
			</div>
		</div>
		<br>
		<br>
		<div class="panel panel-default" style="max-width:600px; margin:auto;">
			<div class="panel-heading text-center lead">
				<?php echo BACKUP_RESTORE_RESTORE_DIS ?>
			</div>
			<div class="panel-body text-center">
				<form name="upload"  id='importForm' action="misc/upload.php" method="POST" ENCTYPE="multipart/form-data">
					<div class="row">
						<div class="col-lg-2 col-lg-offset-2">
							<input type="file" id="iduploadfile" name="uploadfile" data-toggle="tooltip" title="<?php echo BACK_RES_FILE ?>" >
						</div>
					</div>
					<br>
					<div class="row text-center">
						<input type="submit" form="" class="btn btn-default" data-toggle="tooltip" title="<?php echo BACK_RES_UPLOAD ?>" value="<?php echo BUTTON_UPLOAD ?>"
								onclick="var fileName = $('#iduploadfile').val(); if (fileName.length > 0) { if (checkUploadedFile(fileName)!=false) selectFiles();}">
						&nbsp;&nbsp;
						<input type="reset" class="btn btn-default" value="<?php echo BUTTON_RESET ?>" data-toggle="tooltip" title="<?php echo BACK_RES_RESET ?>">
					</div>
				</form>
			</div>
		</div>
		<?php
		$ret .= ob_get_clean();

		return $ret;
	}

}
?>
